package org.blue.club.entities.dto;

import com.mybatisflex.annotation.Id;
import com.mybatisflex.annotation.RelationManyToOne;
import jakarta.annotation.Nullable;
import lombok.Data;
import org.blue.club.entities.vo.data.AuthVo;
import org.blue.club.entities.vo.data.ClubVo;
import org.mmga.spring.boot.starter.interfaces.IdHolder;

@Data
public class User implements IdHolder {
    @Id
    private Long id;
    private String name;
    @Nullable
    private String avatar;
    @RelationManyToOne(selfField = "auth", targetField = "id")
    private AuthVo auth;
    @RelationManyToOne(joinTable = "club_user_auth", selfField = "id", joinSelfColumn = "user_id", targetField = "id", joinTargetColumn = "club_id")
    private ClubVo club;
    @RelationManyToOne(joinTable = "club_user_auth", selfField = "id", joinSelfColumn = "user_id", targetField = "id", joinTargetColumn = "auth_id")
    private AuthVo clubAuth;

    public boolean hasPermission(Long permissionId) {
        return (clubAuth != null && clubAuth.hasPermission(permissionId)) || (auth != null && auth.hasPermission(permissionId));
    }

    public boolean isAuth(Long authId) {
        return (auth != null && authId.equals(auth.getId())) || (clubAuth != null && authId.equals(clubAuth.getId()));
    }
}
