package org.blue.club.entities.dto.req;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Data;
import org.apache.commons.codec.digest.DigestUtils;

import java.util.Objects;

@Schema(name = "用户修改密码请求体")
@Data
@AllArgsConstructor
public class UserChangePasswordRequest {
    @Schema(description = "被修改的用户ID")
    private final Long id;
    @Schema(description = "修改前的密码MD5值", requiredMode = Schema.RequiredMode.NOT_REQUIRED)
    private String oldPassword;
    @Schema(description = "修改后的密码MD5值")
    private final String newPassword;

    public UserChangePasswordRequest sha1HexPassword() {
        String oldPassword = Objects.isNull(this.oldPassword) ? null : DigestUtils.sha1Hex(this.oldPassword);
        String newPassword = Objects.isNull(this.newPassword) ? null : DigestUtils.sha1Hex(this.newPassword);
        return new UserChangePasswordRequest(this.id, oldPassword, newPassword);
    }
}
