package org.blue.club.entities.vo.data;

import com.mybatisflex.annotation.Id;
import com.mybatisflex.annotation.RelationManyToMany;
import com.mybatisflex.annotation.Table;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.List;

@EqualsAndHashCode(callSuper = true)
@Table("auth")
@Data
public class AuthVo extends BaseDataVo {
    @Id
    private Long id;
    private String name;
    @RelationManyToMany(joinTable = "auth_permission",
            selfField = "id", joinSelfColumn = "auth_id",
            targetField = "id", joinTargetColumn = "permission_id"
    )
    private List<PermissionVo> permissions;

    public boolean hasPermission(Long permissionId) {
        return permissions.stream().anyMatch(p -> permissionId.equals(p.getId()));
    }
}
