package org.blue.club.entities.vo.data;

import com.mybatisflex.annotation.Id;
import com.mybatisflex.annotation.RelationManyToOne;
import com.mybatisflex.annotation.Table;
import jakarta.annotation.Nullable;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.mmga.spring.boot.starter.annotation.VoIgnore;

@EqualsAndHashCode(callSuper = true)
@Data
@Table("user")
public class UserVo extends BaseDataVo {
    @Id
    private Long id;
    private String name;
    @VoIgnore
    private String password;
    @VoIgnore
    private Long auth;
    @Nullable
    private String avatar;
    @RelationManyToOne(selfField = "auth", targetField = "id")
    private AuthVo auths;
    @RelationManyToOne(joinTable = "club_user_auth", selfField = "id", joinSelfColumn = "user_id", targetField = "id", joinTargetColumn = "club_id")
    private ClubVo club;
    @RelationManyToOne(joinTable = "club_user_auth", selfField = "id", joinSelfColumn = "user_id", targetField = "id", joinTargetColumn = "auth_id")
    private AuthVo clubAuth;
}
